<?php
namespace Teknisa\Model\Teknisa\Repositories;

class Linpluso extends \Doctrine\ORM\EntityRepository {

    public function getUseLicense($cdCliente, $filter)
    {

        $query = "SELECT CDLINPCLIE,NMLINPCLIE,IDMPROCLINPC,IDLPROCLINPC,NRUSUALINPC,
                      NRACESLINPC,IDTIPLINPC, (IDMPROCLINPC || '/' || IDLPROCLINPC) AS IDMLPROCLINPC
                  FROM CONTRATOLINP
                  WHERE CDCLIENTE     = :P_CDCLIENTE
                  AND DTCONTLINPRESC IS NULL
                  $filter
                  ORDER BY CDLINPCLIE  ";

        $params = array(
            'P_CDCLIENTE' => $cdCliente,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query ,$params);
    }

    public function findCostsPer($cdClient, $limit, $offset, $filter)
    {
        $query = "SELECT *
                    FROM (SELECT LP.CDCLIENTE, LP.CDLINPCLIE, LP.CDLINPCLIEINFOR, LP.NMLINPCLIE, LP.FORMA_CONTROLE AS IDTIPLINPC, LP.NRUSUALINPC,
                         LP.IDMPROCLINPC, LP.IDLPROCLINPC, LP.CDLOCALUSO, LP.NMFANTLUSO, LP.QTVALIDAS,
                          ROUND(LP.VRMENSALIDALINP, 2) AS VRMENSALIDALINP, (ROUND(LP.VRMENSALIDALINP, 2) * LP.QTVALIDAS) AS VRMENSALTOTAL,
                         (LP.IDMPROCLINPC || '/' || LP.IDLPROCLINPC) AS MODE_LOCATION
  FROM (SELECT LU.CDCLIENTE, LU.CDLOCALUSO, LU.NMFANTLUSO, LL.CDLINPCLIE, CL.CDLINPCLIEINFOR, CL.NMLINPCLIE, CL.NRUSUALINPC, CL.IDMPROCLINPC, CL.IDLPROCLINPC,
               DECODE(CL.IDTIPLINPC, 'M', 'LU/MANUTENCAO', 'L', 'LOCACAO', 'P', 'PTO.ACESSO', 'A', 'PTO.ACESSO') FORMA_CONTROLE, 1 AS QTVALIDAS,
               (SELECT MAX(VRMENSCLIE)
                  FROM VALORLINP
                 WHERE SYSDATE BETWEEN DTIVIGVRLINP AND NVL(DTFVIGVRLINP, SYSDATE)
                   AND CDCLIENTE = LL.CDCLIENTE
                   AND CDLINPCLIE = LL.CDLINPCLIE) AS VRMENSALIDALINP
          FROM TABLE (LINHA_PRODUTO_FAT (:P_CDCLIENTE)) CL,
               LINPLUSO LL, LICENCAUSO LU
         WHERE LL.CDCLIENTE = CL.CDCLIENTE
           AND LL.CDLINPCLIE = CL.CDLINPCLIE
           AND LU.CDCLIENTE = LL.CDCLIENTE
           AND LU.NRLICENCAUSO = LL.NRLICENCAUSO
			  AND CL.IDTIPLINPC IN ('M', 'L') 
			  AND SITUACAO_LINPLUSO (LU.IDLUSOATIV, LL.DTVALPERSLUPEND, LL.DTVALPERSLUPAGA, LL.IDLINPEXCLUIDA, SYSDATE, 'VALIDA') = 'VALIDA'
		   UNION ALL																
        SELECT LU.CDCLIENTE, LU.CDLOCALUSO, LU.NMFANTLUSO, LL.CDLINPCLIE, CL.CDLINPCLIEINFOR, CL.NMLINPCLIE, CL.NRUSUALINPC, CL.IDMPROCLINPC, CL.IDLPROCLINPC,
               DECODE(CL.IDTIPLINPC, 'M', 'LU/MANUTENCAO', 'L', 'LOCACAO', 'P', 'PTO.ACESSO', 'A', 'PTO.ACESSO') FORMA_CONTROLE,
               (SELECT COUNT(*)
                  FROM CAIXALUSO CX
                 WHERE CX.CDCLIENTE = LL.CDCLIENTE
                   AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                   AND SITUACAO_LINPLUSO (LU.IDLUSOATIV, CX.DTVALPERSCXPEND, CX.DTVALPERSCXPAGO, CX.IDCAIXAEXCLUIDO, SYSDATE, 'VALIDA') = 'VALIDA') QTDE_CAIXAS_VALIDOS,
               (SELECT MAX(VRMENSPTOA)
                  FROM VALORLINP
                 WHERE SYSDATE BETWEEN DTIVIGVRLINP AND NVL(DTFVIGVRLINP, SYSDATE)
                   AND CDCLIENTE = LL.CDCLIENTE
                   AND CDLINPCLIE = LL.CDLINPCLIE) AS VRMENSALIDALINP    
          FROM TABLE (LINHA_PRODUTO_FAT (:P_CDCLIENTE)) CL,
               LINPLUSO LL, LICENCAUSO LU
         WHERE LL.CDCLIENTE = CL.CDCLIENTE
           AND LL.CDLINPCLIE = CL.CDLINPCLIE
           AND LU.CDCLIENTE = LL.CDCLIENTE
           AND LU.NRLICENCAUSO = LL.NRLICENCAUSO
           AND CL.IDTIPLINPC IN ('P', 'A')
			  AND ((SELECT COUNT(*)
					    FROM CAIXALUSO CX
					   WHERE CX.CDCLIENTE = LL.CDCLIENTE
				  		  AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
						  AND SITUACAO_LINPLUSO (LU.IDLUSOATIV, CX.DTVALPERSCXPEND, CX.DTVALPERSCXPAGO, CX.IDCAIXAEXCLUIDO, SYSDATE, 'VALIDA') = 'VALIDA') <> 0)) LP)
		WHERE 1 = 1
		$filter
		ORDER BY CDLOCALUSO";

        $params = array(
            'P_CDCLIENTE' => $cdClient,
        );
        $query = $this->getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query ,$params);
    }

    public function findCostsPerGroupedFilial($cdClient, $limit, $offset, $filter)
    {
        $query = "SELECT *
                    FROM (SELECT LP.CDLOCALUSO, LP.NMFANTLUSO, SUM(ROUND(LP.VRMENSALIDALINP, 2) * LP.QTVALIDAS) AS VRMENSALIDALINP
                    FROM (SELECT LU.CDCLIENTE, LU.CDLOCALUSO, LU.NMFANTLUSO, LL.CDLINPCLIE, CL.CDLINPCLIEINFOR, CL.NMLINPCLIE,
                                 CL.NRUSUALINPC, CL.IDMPROCLINPC, CL.IDLPROCLINPC,
                                 DECODE(CL.IDTIPLINPC, 'M', 'LU/MANUTENCAO', 'L', 'LOCACAO', 'P', 'PTO.ACESSO', 'A', 'PTO.ACESSO') FORMA_CONTROLE, 1 AS QTVALIDAS,
                                 (SELECT MAX(VRMENSCLIE)
                                    FROM VALORLINP
                                   WHERE SYSDATE BETWEEN DTIVIGVRLINP AND NVL(DTFVIGVRLINP, SYSDATE)
                                     AND CDCLIENTE = LL.CDCLIENTE
                                     AND CDLINPCLIE = LL.CDLINPCLIE) AS VRMENSALIDALINP
                      FROM TABLE (LINHA_PRODUTO_FAT (:P_CDCLIENTE)) CL, LINPLUSO LL, LICENCAUSO LU
                           WHERE LL.CDCLIENTE = CL.CDCLIENTE
                             AND LL.CDLINPCLIE = CL.CDLINPCLIE
                             AND LU.CDCLIENTE = LL.CDCLIENTE
                             AND LU.NRLICENCAUSO = LL.NRLICENCAUSO
                             AND CL.IDTIPLINPC IN ('M', 'L') 
                             AND SITUACAO_LINPLUSO (LU.IDLUSOATIV, LL.DTVALPERSLUPEND, LL.DTVALPERSLUPAGA, LL.IDLINPEXCLUIDA, SYSDATE, 'VALIDA') = 'VALIDA'
                       UNION ALL																
                          SELECT LU.CDCLIENTE, LU.CDLOCALUSO, LU.NMFANTLUSO, LL.CDLINPCLIE, CL.CDLINPCLIEINFOR, CL.NMLINPCLIE, CL.NRUSUALINPC, CL.IDMPROCLINPC, CL.IDLPROCLINPC,
                                 DECODE(CL.IDTIPLINPC, 'M', 'LU/MANUTENCAO', 'L', 'LOCACAO', 'P', 'PTO.ACESSO', 'A', 'PTO.ACESSO') FORMA_CONTROLE,
                                 (SELECT COUNT(*)
                                    FROM CAIXALUSO CX
                                   WHERE CX.CDCLIENTE = LL.CDCLIENTE
                                     AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
                                     AND SITUACAO_LINPLUSO (LU.IDLUSOATIV, CX.DTVALPERSCXPEND, CX.DTVALPERSCXPAGO, CX.IDCAIXAEXCLUIDO, SYSDATE, 'VALIDA') = 'VALIDA') QTDE_CAIXAS_VALIDOS,
                                 (SELECT MAX(VRMENSPTOA)
                                    FROM VALORLINP
                                   WHERE SYSDATE BETWEEN DTIVIGVRLINP AND NVL(DTFVIGVRLINP, SYSDATE)
                                     AND CDCLIENTE = LL.CDCLIENTE
                                     AND CDLINPCLIE = LL.CDLINPCLIE) AS VRMENSALIDALINP    
                      FROM TABLE (LINHA_PRODUTO_FAT (:P_CDCLIENTE)) CL, LINPLUSO LL, LICENCAUSO LU
                           WHERE LL.CDCLIENTE = CL.CDCLIENTE
                             AND LL.CDLINPCLIE = CL.CDLINPCLIE
                             AND LU.CDCLIENTE = LL.CDCLIENTE
                             AND LU.NRLICENCAUSO = LL.NRLICENCAUSO
                             AND CL.IDTIPLINPC IN ('P', 'A')
    			             AND ((SELECT COUNT(*)
                                     FROM CAIXALUSO CX
                                    WHERE CX.CDCLIENTE = LL.CDCLIENTE
				  		              AND CX.NRLICENCAUSO = LL.NRLICENCAUSO
						              AND SITUACAO_LINPLUSO (LU.IDLUSOATIV, CX.DTVALPERSCXPEND, CX.DTVALPERSCXPAGO, CX.IDCAIXAEXCLUIDO, SYSDATE, 'VALIDA') = 'VALIDA') <> 0)) LP
                        GROUP BY CDLOCALUSO, NMFANTLUSO)
				WHERE 1 = 1
		        $filter
                ORDER BY CDLOCALUSO";

        $params = array(
            'P_CDCLIENTE' => $cdClient,
        );
        $query = $this->getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query ,$params);
    }

    public static function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $limit . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $limit;
            }
        }
        return $query;
    }
    
}
